#include "../binary_c.h"
No_empty_translation_unit_warning;

#ifdef NUCSYN

#ifdef __HAVE_LIBSUNDIALS_CVODE__

#include "../maths/cvode.h"
#include <cvode/cvode.h>

/*
 * Network code : pp
 * Automatically generated by make_reaction_network_code.pl
 */

/*
 * Reaction SIGMAV_PP H1(H1,beta)H2
 * Alpha=H1, beta=, gamma=beta, delta=H2
 * m=2, n=, p=1, q=1
 */
/*
 * Reaction SIGMAV_DP H2(H1,gamma0)He3
 * Alpha=H2, beta=H1, gamma=gamma0, delta=He3
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_He3_He3 He3(He3,2H1)He4
 * Alpha=He3, beta=, gamma=H1, delta=He4
 * m=2, n=, p=2, q=1
 */
/*
 * Reaction SIGMAV_He3_He4 He3(He4,gamma0)Be7
 * Alpha=He3, beta=He4, gamma=gamma0, delta=Be7
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_Be7_e Be7(e,gamma0)Li7
 * Alpha=Be7, beta=e, gamma=gamma0, delta=Li7
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_Be7_p Be7(H1,He4)He4
 * Alpha=Be7, beta=H1, gamma=He4, delta=He4
 * m=1, n=1, p=1, q=1
 */
/*
 * Reaction SIGMAV_Li7_p_alpha Li7(H1,He4)He4
 * Alpha=Li7, beta=H1, gamma=He4, delta=He4
 * m=1, n=1, p=1, q=1
 */


/*
 * Species / Reactions list:
 *
 * 1 : e : -Be7*e*SIGMAV_Be7_e
 * 2 : H1 : -0.5*H1*H1*SIGMAV_PP -H2*H1*SIGMAV_DP +He3*He3*SIGMAV_He3_He3 -Be7*H1*SIGMAV_Be7_p -Li7*H1*SIGMAV_Li7_p_alpha
 * 3 : H2 : +0.5*H1*H1*SIGMAV_PP -H2*H1*SIGMAV_DP
 * 4 : He3 : +H2*H1*SIGMAV_DP -0.5*He3*He3*SIGMAV_He3_He3 -He3*He4*SIGMAV_He3_He4
 * 5 : He4 : +0.5*He3*He3*SIGMAV_He3_He3 -He3*He4*SIGMAV_He3_He4 +2*Be7*H1*SIGMAV_Be7_p +2*Li7*H1*SIGMAV_Li7_p_alpha
 * 6 : Li7 : +Be7*e*SIGMAV_Be7_e -Li7*H1*SIGMAV_Li7_p_alpha
 * 7 : Be7 : +He3*He4*SIGMAV_He3_He4 -Be7*e*SIGMAV_Be7_e -Be7*H1*SIGMAV_Be7_p
 *
 */
#define NSPECIES 7

/*
 * Order in which to map from binary_c's isotope
 * array, N[], to y[] used in CVODE. Note that the
 * first element is ignored because CVODE starts
 * counting at 1, use an isotope that exists
 * but is not of interest.
 */
#define PPMAP_LIST \
    X(   e)        \
    X(  H1)        \
    X(  H2)        \
    X( He3)        \
    X( He4)        \
    X( Li7)        \
    X( Be7)
#undef X
#define X(ISO) MAP_##ISO,
enum { _DUMMY, PPMAP_LIST };
#undef X



static int ppderivatives_cvode(realtype t,
                               N_Vector y,
                               N_Vector ydot,
                               void *user_data);

static int ppjacobian_cvode(realtype t Maybe_unused,
                            N_Vector y Maybe_unused,
                            N_Vector fy Maybe_unused,
                            SUNMatrix J Maybe_unused,
                            void *user_data,
                            N_Vector tmp1 Maybe_unused,
                            N_Vector tmp2 Maybe_unused,
                            N_Vector tmp3 Maybe_unused);
static Boolean was_error(void *returnvalue, int opt);

double nucsyn_burn_cvode_pp(struct stardata_t * const Restrict stardata,
                            double * const Nin,
                            const double * const sigmav,
                            const double h)
{
    /*
     * https://computing.llnl.gov/projects/sundials/cvode
     *
     * https://computing.llnl.gov/sites/default/files/cv_guide-5.7.0.pdf
     * https://computing.llnl.gov/sites/default/files/cv_examples-5.7.0.pdf
     */
    double err=0.0;

    /*
     * data passed in to the derivatives function
     */
    struct cvode_data_t data;
    data.sigmav = (double*)sigmav;
    data.N = (double*)Nin;
    data.stardata = stardata;

    int retval;

    /*
     * Get a pointer to the tmpstore context
     * structure, or allocate it.
     */
    struct cvode_context_t * c = stardata->tmpstore->cvode[NUCSYN_NETWORK_PP];
    if(c == NULL)
    {
        /*
         * Allocate CVODE context struct
         */
        c = Calloc(1,sizeof(struct cvode_context_t));
        stardata->tmpstore->cvode[NUCSYN_NETWORK_PP] = c;
    }

    if(c->cvode_mem == NULL)
    {
        /*
         * Initialize memory in the context structure.
         */
        c->y = N_VNew_Serial(NSPECIES);
        if(was_error((void *)c->y, 0) == TRUE)
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /*
         * set initial values c->y from Nin
         */
#define X(ISO) Ith(c->y,i) = Nin[X##ISO]; i++;
        { int i = 1 ; PPMAP_LIST; }
#undef X

        /* Call CVodeCreate to create the solver memory and specify the
         * Backward Differentiation Formula */
        c->cvode_mem = CVodeCreate(CV_BDF);
        if(was_error((void *)c->cvode_mem, 0) == TRUE)
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /* Call CVodeInit to initialize the integrator memory and specify the
         * user's right hand side function in y'=f(t,y), the inital time 0.0, and
         * the initial dependent variable vector y. */
        retval = CVodeInit(c->cvode_mem, ppderivatives_cvode, 0.0, c->y);
        if(was_error(&retval, 1))
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /*
         * Attach our data to the cvode memory block
         */
        CVodeSetUserData(c->cvode_mem, (void*)&data);

        /* Create dense SUNMatrix for use in linear solves */
        c->A = SUNDenseMatrix(NSPECIES, NSPECIES);
        if(was_error((void *)c->A, 0))
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /* Create dense SUNLinearSolver object for use by CVode */
        c->LS = SUNLinSol_Dense(c->y, c->A);
        if(was_error((void *)c->LS, 0))
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /* Create serial vector of length NSPECIES abstol */
        c->abstol = N_VNew_Serial(NSPECIES);
        if(was_error((void *)c->abstol, 0))
        {
            Exit_binary_c(BINARY_C_ALLOC_FAILED,
                          "Could not allocate memory for CVODE c->y array\n");
        }

        /* Call CVodeSetLinearSolver to attach the matrix and linear solver to CVode */
        retval = CVodeSetLinearSolver(c->cvode_mem, c->LS, c->A);
        if(was_error(&retval, 1))
        {
            Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                          "CVODE returned %d : failed to attach matrix and linear solver\n",retval);
        }

        /* Set the user-supplied Jacobian routine  */
        retval = CVodeSetJacFn(c->cvode_mem, ppjacobian_cvode);
        if(was_error(&retval, 1))
        {
            Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                          "CVODE returned %d : failed to set Jacobian\n",retval);
        }
    }
    else
    {
        /*
         * set initial values c->y from Nin
         */
#define X(ISO) Ith(c->y,i) = Nin[X##ISO]; i++;
        { int i = 1 ; PPMAP_LIST; }
#undef X

        /*
         * We need to call CVodeReInit
         */
        CVodeReInit(c->cvode_mem,0.0,c->y);
        /*
         * Re-Attach our data to the cvode memory block,
         * in case some of it has changed
         */
        CVodeSetUserData(c->cvode_mem, (void*)&data);
    }


    /* Set the scalar relative tolerance */
    const realtype reltol = 1e-10;

    /*
     * Set the vector absolute tolerance
     * from 1e-3 * abundance
     */
#define X(ISO) Ith(c->abstol,i) = Max(1.0,1e-40*Nin[X##ISO]); i++;
    { int i = 1; PPMAP_LIST; }
#undef X

    /*
     * Set max number of steps
     */
    CVodeSetMaxNumSteps(c->cvode_mem, LONG_MAX);

    /*
     * Call CVodeSVtolerances to specify the tolerances
     */
    retval = CVodeSVtolerances(c->cvode_mem, reltol, c->abstol);
    if(was_error(&retval, 1))
    {
        Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                      "CVODE returned %d : failed to set tolerances\n",retval);
    }

    /*
     * Call CVODE solver.
     */
    realtype t = 0.0;

    retval = CVode(c->cvode_mem, h, c->y, &t, CV_NORMAL);
    if(retval != 0.0)
    {
        Exit_binary_c(BINARY_C_NUCSYN_SOLVER_FAILED,
                      "CVODE returned %d\n",retval);
    }


    /* CVODE to C */
#define X(ISO) (Nin)[X##ISO] = Ith(c->y,i); i++;
    { int i = 1 ; PPMAP_LIST; }
#undef X
    return err;
}



static int ppderivatives_cvode(realtype t Maybe_unused,
                               N_Vector y Maybe_unused,
                               N_Vector ydot,
                               void *user_data Maybe_unused)
{
    struct cvode_data_t * const Restrict cvode_data =
        (struct cvode_data_t * const Restrict)user_data;
    const double * const Restrict sigmav =
        (const double * const Restrict) cvode_data->sigmav;

    /*
     * Note: you must set all the items in ydot,
     * they are not automatically set to zero by CVODE.
     */
    const double dummy0 = Ith(y,6) * Ith(y,2) * sigmav[SIGMAV_Li7_p_alpha] ;
    const double dummy1 = Ith(y,7) * Ith(y,2) * sigmav[SIGMAV_Be7_p] ;
    const double dummy5 = Ith(y,2) * Ith(y,2) * sigmav[SIGMAV_PP] ;
    const double dummy6 = Ith(y,3) * Ith(y,2) * sigmav[SIGMAV_DP] ;


    const double dummy3 = Ith(y,7) * Ith(y,1) * sigmav[SIGMAV_Be7_e] ;
    const double dummy2 = Ith(y,4) * Ith(y,5) * sigmav[SIGMAV_He3_He4] ;
    const double dummy4 = Ith(y,4) * Ith(y,4) * sigmav[SIGMAV_He3_He3] ;
    Ith(ydot,1) = - dummy3 ;
    Ith(ydot,2) = (- 0.5*dummy5  - dummy6- dummy1)  + dummy4    - dummy0 ;
    Ith(ydot,3) = + 0.5*dummy5  - dummy6 ;
    Ith(ydot,4) = (+ dummy6)  - 0.5*dummy4  - dummy2 ;
    Ith(ydot,5) = + 0.5*dummy4  - dummy2  + (2.0*dummy1  + 2.0*dummy0) ;
    Ith(ydot,6) = + dummy3  - dummy0 ;
    Ith(ydot,7) = + dummy2  - dummy3  - dummy1 ;
    return 0;
}

static int ppjacobian_cvode(realtype t Maybe_unused,
                            N_Vector y Maybe_unused,
                            N_Vector fy Maybe_unused,
                            SUNMatrix J Maybe_unused,
                            void *user_data,
                            N_Vector tmp1 Maybe_unused,
                            N_Vector tmp2 Maybe_unused,
                            N_Vector tmp3 Maybe_unused)
{
    struct cvode_data_t * const Restrict cvode_data =
        (struct cvode_data_t * const Restrict)user_data;
    const double * const Restrict sigmav =
        (const double * const Restrict) cvode_data->sigmav;
    /*
     * Note: J is zero on entry, according to the CVOD
     * documentation...
     */
    /*
    for(int i=1;i<=NSPECIES;i++)
    {
        for(int j=1;j<=NSPECIES;j++)
        {
            IJth(J,i,j) = 0.0;
        }
    }
    */
    const double dummy0 = Ith(y,MAP_He3) * sigmav[SIGMAV_He3_He4] ;
    const double dummy1 = Ith(y,MAP_e) * sigmav[SIGMAV_Be7_e] ;
    const double dummy2 = Ith(y,MAP_H1) * sigmav[SIGMAV_Be7_p] ;
    const double dummy3 = Ith(y,MAP_He3) * sigmav[SIGMAV_He3_He3] ;
    const double dummy4 = Ith(y,MAP_H1) * sigmav[SIGMAV_DP] ;
    const double dummy5 = Ith(y,MAP_Be7) * sigmav[SIGMAV_Be7_p] ;
    const double dummy6 = Ith(y,MAP_H2) * sigmav[SIGMAV_DP] ;
    const double dummy7 = Ith(y,MAP_H1) * sigmav[SIGMAV_Li7_p_alpha] ;
    const double dummy8 = Ith(y,MAP_Li7) * sigmav[SIGMAV_Li7_p_alpha] ;
    const double dummy9 = Ith(y,MAP_Be7) * sigmav[SIGMAV_Be7_e] ;
    const double dummy10 = Ith(y,MAP_H1) * sigmav[SIGMAV_PP] ;
    const double dummy11 = Ith(y,MAP_He4) * sigmav[SIGMAV_He3_He4] ;

    IJth(J,1,1) = - dummy9;
    IJth(J,1,7) =   - dummy1;
    IJth(J,2,2) =   - dummy8  - dummy5  - dummy10  - dummy6;
    IJth(J,2,3) =   - dummy4;
    IJth(J,2,4) =   + 2.0*dummy3;
    IJth(J,2,6) =   - dummy7;
    IJth(J,2,7) =   - dummy2;
    IJth(J,3,2) =   + dummy10  - dummy6;
    IJth(J,3,3) =   - dummy4;
    IJth(J,4,2) =   + dummy6;
    IJth(J,4,3) =   + dummy4;
    IJth(J,4,4) =   - dummy11  - dummy3;
    IJth(J,4,5) =   - dummy0;
    IJth(J,5,2) =   + 2.0*dummy5  + 2.0*dummy8;
    IJth(J,5,4) =   - dummy11  + dummy3;
    IJth(J,5,5) =   - dummy0;
    IJth(J,5,6) =   + 2.0*dummy7;
    IJth(J,5,7) =   + 2.0*dummy2;
    IJth(J,6,1) =   + dummy9;
    IJth(J,6,2) =   - dummy8;
    IJth(J,6,6) =   - dummy7;
    IJth(J,6,7) =   + dummy1;
    IJth(J,7,1) =   - dummy9;
    IJth(J,7,2) =   - dummy5;
    IJth(J,7,4) =   + dummy11;
    IJth(J,7,5) =   + dummy0;
    IJth(J,7,7) =   - dummy1  - dummy2;

    return 0;
}

static Boolean was_error(void *returnvalue,
                         int opt)
{
    /*
     * return TRUE on error
     */
    return ((opt == 0 && returnvalue == NULL)||
            (opt == 1 && *((int*)returnvalue)<0) ||
            (opt == 2 && returnvalue == NULL)) ? TRUE : FALSE;
}

#endif // __HAVE_LIBSUNDIALS_CVODE__



#endif // NUCSYN &&
